//+------------------------------------------------------------------+
//|                                                     smoothed rsi |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1   DeepSkyBlue
#property indicator_width1   3
#property indicator_minimum  -5
#property indicator_maximum  105
#property indicator_level1   20.0
#property indicator_level2   30.0
#property indicator_level3   40.0
#property indicator_level4   50.0
#property indicator_level5   60.0
#property indicator_level6   70.0
#property indicator_level7   80.0
#property indicator_levelcolor Olive


//
//
//
//
//



extern int    Price           = PRICE_CLOSE;
extern bool   Smoothed        = true;
extern string infoa           = " mode settings ";
extern string info1           = " 1 = period of Dominant Cycle";
extern string info2           = " 2 = Amplitude of Dominant Cycle";
extern string info3           = " 3 = Phase of Dominant Cycle";
extern int    mode            = 1;
extern int    price           = PRICE_MEDIAN;
extern int    smooth          = 5;
extern bool   Show_10_90      = TRUE;
extern int    IndicatorWindow = 2;
extern color  extralevelcolor = Olive;




//
//
//
//
//

double rsi[];
double prc[];

int    Length;





//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
      IndicatorBuffers(2);
      SetIndexBuffer(0,rsi);
      SetIndexBuffer(1,prc);
   
           
         

   //
   //
   //
   //
   //

         
         
         string PriceType;
         switch(Price)
         {
            case PRICE_CLOSE:    PriceType = "Close";    break;  // 0
            case PRICE_OPEN:     PriceType = "Open";     break;  // 1
            case PRICE_HIGH:     PriceType = "High";     break;  // 2
            case PRICE_LOW:      PriceType = "Low";      break;  // 3
            case PRICE_MEDIAN:   PriceType = "Median";   break;  // 4
            case PRICE_TYPICAL:  PriceType = "Typical";  break;  // 5
            case PRICE_WEIGHTED: PriceType = "Weighted"; break;  // 6
         } 
         if (Show_10_90) 
        {
        ObjectCreate("90_LINE", OBJ_HLINE, IndicatorWindow, 0, 90);
        ObjectSet("90_LINE", OBJPROP_COLOR, extralevelcolor);
        ObjectSet("90_LINE", OBJPROP_WIDTH, 1);
        ObjectSet("90_LINE", OBJPROP_STYLE, STYLE_DOT);
        ObjectCreate("10_LINE", OBJ_HLINE, IndicatorWindow, 0, 10);
        ObjectSet("10_LINE", OBJPROP_COLOR, extralevelcolor);
        ObjectSet("10_LINE", OBJPROP_WIDTH, 1);
        ObjectSet("10_LINE", OBJPROP_STYLE, STYLE_DOT);
        }
         
      

  
      string addName = "";
         if (Smoothed) addName = "smoothed ";
   IndicatorShortName(" adaptive RSI "+addName+"("+PriceType+")");
   return(0);
}
int deinit()  
{
 ObjectDelete("10_LINE");
 ObjectDelete("90_LINE"); 
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,n,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

 
      for(i=limit; i >= 0; i--)
      {
             Length    =   iHilbert(iMA(NULL,0,1,0,MODE_SMA,price,i),mode,smooth,i)/2;
         if (Smoothed)
               prc[i]  = (iMA(NULL,0,1,0,MODE_SMA,Price,i)+2.0*iMA(NULL,0,1,0,MODE_SMA,Price,i+1)+iMA(NULL,0,1,0,MODE_SMA,Price,i+2))/4.0;
         else  prc[i]  =  iMA(NULL,0,1,0,MODE_SMA,Price,i);
         if (i>=Bars-Length) continue;
      
         double cu = 0;
         double cd = 0;
         for (k=0; k<Length; k++)
            {
               double diff = prc[i+k]-prc[i+k+1];
                  if (diff > 0)
                        cu += diff;
                  else  cd -= diff;
            }
         if ((cu+cd)!=0)
               rsi[i] = 50.0*((cu-cd)/(cu+cd)+1.0);
         else  rsi[i] = 0;

         //
         //
         //
         //
         //
         
           
      }
 
      return(0);
   } 
   

double workHil[][13];
#define _price     0
#define _smooth    1
#define _detrender 2
#define _period    3
#define _Q1        4
#define _I1        5
#define _JI        6
#define _JQ        7
#define _Q2        8
#define _I2        9
#define _Re       10
#define _Im       11
#define _res      12

#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iHilbert(double price, int mode, double smooth, int i, int s=0)
{
   if (ArrayRange(workHil,0)!=Bars) ArrayResize(workHil,Bars);
   int r = Bars-i-1; s = s*13;
      
   //
   //
   //
   //
   //
      
      workHil[r][s+_price]     = price;
      workHil[r][s+_smooth]    = (4.0*workHil[r][s+_price]+3.0*workHil[r-1][s+_price]+2.0*workHil[r-2][s+_price]+workHil[r-3][s+_price])/10.0;
      workHil[r][s+_detrender] = calcComp(r,_smooth,s);
      workHil[r][s+_Q1]        = calcComp(r,_detrender,s);
      workHil[r][s+_I1]        = workHil[r-3][s+_detrender];
      workHil[r][s+_JI]        = calcComp(r,_I1,s);
      workHil[r][s+_JQ]        = calcComp(r,_Q1,s);

      workHil[r][s+_I2]        = 0.2*(workHil[r][s+_I1]-workHil[r][s+_JQ])                                         + 0.8*workHil[r-1][s+_I2];
      workHil[r][s+_Q2]        = 0.2*(workHil[r][s+_Q1]+workHil[r][s+_JI])                                         + 0.8*workHil[r-1][s+_Q2];
      workHil[r][s+_Re]        = 0.2*(workHil[r][s+_I2]*workHil[r-1][s+_I2]+workHil[r][s+_Q2]*workHil[r-1][s+_Q2]) + 0.8*workHil[r-1][s+_Re];
      workHil[r][s+_Im]        = 0.2*(workHil[r][s+_I2]*workHil[r-1][s+_Q2]-workHil[r][s+_Q2]*workHil[r-1][s+_I2]) + 0.8*workHil[r-1][s+_Im];

      if (workHil[r][s+_Re]!= 0 && workHil[r][s+_Im]!=0) 
          workHil[r][s+_period] = 2.0*Pi/(MathArctan(workHil[r][s+_Im]/workHil[r][s+_Re]));
          workHil[r][s+_period] = MathMin(workHil[r][s+_period],1.50*workHil[r-1][s+_period]);
          workHil[r][s+_period] = MathMax(workHil[r][s+_period],0.67*workHil[r-1][s+_period]);
          workHil[r][s+_period] = MathMin(MathMax(workHil[r][s+_period],6),50);
          workHil[r][s+_period] = 0.2*workHil[r][s+_period]+0.8*workHil[r-1][s+_period];

   //
   //
   //
   //
   //

   double alpha = 2.0/(1.0+MathMax(smooth,1));
   switch (mode)
   {
      case 1 : 
            workHil[r][s+_res] = workHil[r-1][s+_res]+alpha*(workHil[r][s+_period]-workHil[r-1][s+_res]);
            break;
            
      //
      //
      //
      //
      //
                  
      case 2 :
            double damp = MathSqrt(workHil[r][s+_Re]*workHil[r][s+_Re] + workHil[r][s+_Im]*workHil[r][s+_Im])/Point;
                                   workHil[r][s+_res] = workHil[r-1][s+_res]+alpha*(damp-workHil[r-1][s+_res]); 
            break;
            
      //
      //
      //
      //
      //
                  
      case 3 : 
            double phase;
               if (workHil[r][s+_I1] != 0.0) 
                     phase = 180.0/Pi*MathArctan(workHil[r][s+_Q1]/workHil[r][s+_I1]);
               else  phase = 180.0;
            workHil[r][s+_res] = workHil[r-1][s+_res]+alpha*(phase-workHil[r-1][s+_res]);
            break;
   }         
   return (workHil[r][s+_res]);
}

//
//
//
//
//

double calcComp(int r, int from, int s)
{
   return((0.0962*workHil[r  ][s+from] + 
           0.5769*workHil[r-2][s+from] - 
           0.5769*workHil[r-4][s+from] - 
           0.0962*workHil[r-6][s+from]) * (0.075*workHil[r-1][s+_period] + 0.54));
}